<template>
  <v-container>
    <v-row no-gutters justify="space-between">
      <login-card v-if="!$store.getters.isLoggedIn" />
      <register-card v-if="!$store.getters.isLoggedIn" />
      <v-col v-if="$store.getters.isLoggedIn" cols='3' style="min-width:256px" class='pa-1'>
        <v-card min-width="256" class="fill-height">
          <v-card-title>
            Reactor
          </v-card-title>
          <v-card-text>
            <v-row>
              <v-col :align-self="'center'" class="text-left">
                  Charge {{ Math.ceil(charge) }}%
              </v-col>
              <v-col>
                <v-row :justify="'end'" class="pr-3">
                  <v-switch v-model="reactoryIsOn" class='ma-0' hide-details=true dense label="On"></v-switch>
                </v-row>
              </v-col>
            </v-row>
            <v-progress-linear :value="charge"></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-col>
      <navigation-card v-if="$store.getters.isLoggedIn"/>
      <helm-system-card v-if="$store.getters.isLoggedIn"/>
      <v-col cols='3' style="min-width:256px" class='pa-1'>
        <v-card min-width="256" class="fill-height">
          <v-card-title>
            Walkie talkie
          </v-card-title>
          <v-card-text>
            <v-text-field type="text" v-model="socketBox"></v-text-field>
            <v-btn @click="sendMsg" color="success">Send</v-btn>
          </v-card-text>
        </v-card>
      </v-col>
      <radio-receiver-card v-if="$store.getters.isLoggedIn"/>
    </v-row>
  </v-container>
</template>

<script>
import LoginCard from "./cards/LoginCard"
import RegisterCard from "./cards/RegisterCard"
import NavigationCard from "./cards/NavigationCard"
import HelmSystemCard from "./cards/HelmSystemCard"
import RadioReceiverCard from "./cards/RadioReceiverCard"

export default {
  name: 'CrudeTools',

  data: () => ({
    socketBox: "",
    ticker: {
      reactor: null,
    },
    radioContacts: [
      {
        title: 'Unknown contact',
        direction: 0,
        distance: 0,
        
      },
    ],
  }),
  mounted () {
  },
  methods: {
    sendMsg () {
      console.log("sendout")
      const command = this.socketBox.trim().split('<>')
      this.$socket.emit(command[0], JSON.parse(command[1]))
      this.socketBox=""
    },
  },
  computed: {
    charge: {
      get () {
        return this.$store.getters.get_charge
      }, 
      set (value) {
        this.$store.commit("set_charge", value)
      }
    },
    reactoryIsOn: {
      get () {
        console.log("%cReactor received new reactor state", "color:red;")
        if (this.$store.getters.reactoryIsOn) {
          console.log("On", "color:green;")
          if (this.ticker.reactor == null) {
            this.reactorTick()
            this.ticker.reactor = setInterval(this.reactorTick, 500)
          }
        } else {
          if (this.ticker.reactor != null) {
            clearInterval(this.ticker.reactor)
            this.ticker.reactor = null
          }
        }
        return this.$store.getters.reactoryIsOn
      },
      set (val) {
        if (val) {
          this.$store.dispatch("turn_reactor_on")
        } else {
          this.$store.dispatch("turn_reactor_off")
        }
      }
    },
  },
  components: {LoginCard, RegisterCard, NavigationCard, HelmSystemCard, RadioReceiverCard}
}
</script>
